const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Identity_accountsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const identity_accounts = await db.identity_accounts.create(
      {
        id: data.id || undefined,

        idp: data.idp || null,
        username: data.username || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await identity_accounts.setEmployee(data.employee || null, {
      transaction,
    });

    await identity_accounts.setOrganizations(data.organizations || null, {
      transaction,
    });

    return identity_accounts;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const identity_accountsData = data.map((item, index) => ({
      id: item.id || undefined,

      idp: item.idp || null,
      username: item.username || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const identity_accounts = await db.identity_accounts.bulkCreate(
      identity_accountsData,
      { transaction },
    );

    // For each item created, replace relation files

    return identity_accounts;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const identity_accounts = await db.identity_accounts.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.idp !== undefined) updatePayload.idp = data.idp;

    if (data.username !== undefined) updatePayload.username = data.username;

    updatePayload.updatedById = currentUser.id;

    await identity_accounts.update(updatePayload, { transaction });

    if (data.employee !== undefined) {
      await identity_accounts.setEmployee(
        data.employee,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await identity_accounts.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return identity_accounts;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const identity_accounts = await db.identity_accounts.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of identity_accounts) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of identity_accounts) {
        await record.destroy({ transaction });
      }
    });

    return identity_accounts;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const identity_accounts = await db.identity_accounts.findByPk(id, options);

    await identity_accounts.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await identity_accounts.destroy({
      transaction,
    });

    return identity_accounts;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const identity_accounts = await db.identity_accounts.findOne(
      { where },
      { transaction },
    );

    if (!identity_accounts) {
      return identity_accounts;
    }

    const output = identity_accounts.get({ plain: true });

    output.employee = await identity_accounts.getEmployee({
      transaction,
    });

    output.organizations = await identity_accounts.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.employees,
        as: 'employee',

        where: filter.employee
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.employee
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.employee
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.idp) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('identity_accounts', 'idp', filter.idp),
        };
      }

      if (filter.username) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'identity_accounts',
            'username',
            filter.username,
          ),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.identity_accounts.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('identity_accounts', 'username', query),
        ],
      };
    }

    const records = await db.identity_accounts.findAll({
      attributes: ['id', 'username'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['username', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.username,
    }));
  }
};
